###############Not for R!!!#############
# #1fastq file
sample.fastq

# #2fastq file seq only
seq.txt

#match #1 into PCRE
^((?!@).).+(GATC)+.+$

#match #1&#2 into R
.+(GATC).+

#description file
^([a-zA-Z]+)\.([a-zA-Z0-9]+)\.([a-zA-Z0-9_]+)\.([0-9]+)[[:space:]](.+)(\.fastq\.gz)
#For R
^([a-zA-Z]+)\\.([a-zA-Z0-9]+)\\.([a-zA-Z0-9_]+)\\.([0-9]+)
(.+)(\\.fastq\\.gz)

###############Not for R!!!#############
rm(list=ls())
source("http://bioconductor.org/biocLite.R")
biocLite("ShortRead")
library(ShortRead)
sample <- readFastq(getwd(), pattern="sample.fastq")
str(sample)
length(sample@sread)

a <- as.character(sample@sread)
writeLines(a, con = "seq.txt", sep = "\n", useBytes = FALSE)

# Search
grep("GATC", sample@sread, perl=TRUE, value=TRUE)
grep("GATC", sample@sread, perl=TRUE, value=FALSE)

grepl("GATC", sample@sread, perl=TRUE)

regexpr("GATC", sample@sread, perl=TRUE)
regmatches(sample@sread, regexpr("GATC", sample@sread, perl=TRUE))

gregexpr("GATC", sample@sread, perl=TRUE)
regmatches(sample@sread, gregexpr("GATC", sample@sread, perl=TRUE))

# Replace
sub("GATC", " empty_string ", sample@sread, perl=TRUE)
gsub("GATC", " empty_string ", sample@sread, perl=TRUE)

# Regex Sample
grep("^GATC", sample@sread, perl=TRUE, value=TRUE)
grep("GATC$", sample@sread, perl=TRUE, value=TRUE)

# GATC on read edge
grep("^(GATC).+(GATC)$", sample@sread, perl=TRUE, value=TRUE)

# Two GATC motives, nothing else 
grep("(.*GATC.*){2}", sample@sread, perl=TRUE, value=TRUE)
grepl("(.*GATC.*){2}", sample@sread, perl=TRUE)

# Search inner GATC motives
grep(".+(GATC).+", sample@sread, perl=TRUE, value=FALSE)

# Search one GATC motives and output with environment
select <- grep("(.*)([ATGC]{2})(GATC)([ATGC]{6})(.*)", sample@sread, perl=TRUE, value=TRUE)
sub("(.*)([ATGC]{2})(GATC)([ATGC]{6})(.*)", "\\2\\3\\4", select, perl=TRUE)

# Variable in RegEx
gatc <- "(.*)([ATGC]{2})(GATC)([ATGC]{6})(.*)"
grep(gatc, sample@sread, perl=TRUE, value=TRUE)

a <- "GATC"
gatc <- paste("(.*)([ATGC]{2})(", a, ")([ATGC]{6})(.*)", sep="")
grep(gatc, sample@sread, perl=TRUE, value=TRUE)

a <- "TATA"
gatc <- paste("(.*)([ATGC]{2})(", a, ")([ATGC]{6})(.*)", sep="")
grep(gatc, sample@sread, perl=TRUE, value=TRUE)

# Practical use. Generate list source file
damid <- read.delim("damid_description.csv", header=T, sep="\t", stringsAsFactors=F)

grep("^([a-zA-Z]+)\\.([a-zA-Z0-9]+)\\.([a-zA-Z0-9_]+)\\.([0-9]+)", damid$Data.set, perl=TRUE, value=TRUE)
grep("(.+)(\\.fastq\\.gz)", damid$fastq.file, perl=TRUE, value=TRUE)

fin <- as.data.frame(matrix(data=NA, nrow=nrow(damid), ncol=6, dimnames=NULL))
ins <- "_inner"
names(fin) <- c("id", "tissue", "protein", "conditions", "replicate", "path")

fin$path <- gsub("(.+)(\\.fastq\\.gz)", paste("\\1", ins, "_local_GATCcounts.RData", sep=""), damid$fastq.file, perl=TRUE)

for (name in names(fin)[1:5]){
colnumber <- which( colnames(fin)==name ) # or grep(name, colnames(fin))
if (colnumber == 1){
subst <- paste("\\1\\.\\2\\.\\3", ins, "\\.\\4", sep="")
} else if (colnumber %in% c(2,3,5)){
subst <- paste("\\", colnumber - 1, sep="")
} else {
subst <- paste("\\3", ins, sep="")
}
fin[[name]] <- gsub("^([a-zA-Z]+)\\.([a-zA-Z0-9]+)\\.([a-zA-Z0-9_]+)\\.([0-9]+)", subst, damid$Data.set, perl=TRUE)
}

write.table(fin, file="rdata_description.csv", sep=";", row.names=F, col.names=T, quote=F, dec=".", append=F)

# Practical use. Match non-english characters by RegEx
# Theory 
http://unicode-table.com/ru/blocks/cyrillic/
http://jrgraphix.net/r/Unicode/0400-04FF
https://codepoints.net/cyrillic
[\x{0400}-\x{04FF}]
\p{L}+

rm(list=ls())
our <- read.csv("our_worker.csv", sep=";", stringsAsFactors=F)
our <- cbind(our, as.data.frame(matrix(data=NA, ncol=3, nrow=nrow(our))))
names(our)[5:7] <- c("SecondName", "FirstName", "SurName")
our$Name <- gsub("[[:space:]]+", " ", our$Name, perl=T)

grep("\\x{041B}\\x{0435}\\x{043E}\\x{043D}\\x{0438}\\x{0434}", our$Name, perl=T, value=T)
grep("", our$Name, perl=T, value=T)

our$SecondName <- gsub("^(\\pL+)[[:space:]](\\pL+)[[:space:]](\\pL+)$", "\\1", our$Name, perl=T)
our$FirstName <- gsub("^(\\pL+)[[:space:]](\\pL+)[[:space:]](\\pL+)$", "\\2", our$Name, perl=T)
our$SurName <- gsub("^(\\pL+)[[:space:]](\\pL+)[[:space:]](\\pL+)$", "\\3", our$Name, perl=T)
write.table(our, "our_worker_mod.csv", sep=";", fileEncoding="UTF-8", append=F, row.names=F, eol="\r\n")
